/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
 /************************************************
 ϺԭƼ޹˾
 Եģ飺 IMU614E
 ڽ
 ֻѧϰʹã۲;
 2IMU614Eݺн
  1printfӡ
 http://www.forsense.cn/
************************************************/
/* USER CODE END Header *//* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "iwdg.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"
#include "serial_parse.h"



 void SystemClock_Config(void);
 extern ParseUnion   rxdata_union;
 static uint8_t RxBuffer=0;  //ڽջ
 uint8_t ReceiveFlag=0;//ɹ־λ 1ɹ 0δɹ

//
	// uint8_t cmd[34]={0x55,0xaa,0x03,0x00,0x18,0x00,0x00,0x00,0xbe,0x42,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc6,0x88,0x48,0x82};
	uint8_t cmd[34]={0x55,0xaa,0x03,0x00,0x18,0x00,0x00,0x00,0x80,0x3f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xd8,0x8e,0xe8};

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{

  HAL_Init();
  SystemClock_Config();
  MX_GPIO_Init();
  MX_USART1_UART_Init();//ӡ
  MX_USART2_UART_Init();//IMU614ݴ
  HAL_TIM_Base_Start_IT(&htim6);     // жģʽʱ
  HAL_UART_Receive_IT(&huart2, &RxBuffer, 1);/* ʹܴ1ж */
  HAL_UART_Transmit(&huart2, (uint8_t *)&cmd, sizeof(cmd), 0xffff);//ģʽ
  while (1)
  {
	  if(ReceiveFlag)//ݽɹ־λ
	  {
	     ReceiveFlag=0;
		 printf("ȡ¶ֵΪ%2.1f\r\n", rxdata_union.AHRS_DATA.imu[6]);
	     printf("ȡֵΪ%.3f\r\n", rxdata_union.AHRS_DATA.roll);
	     printf("ȡֵΪ%.3f\r\n", rxdata_union.AHRS_DATA.pitch);
		 printf("ȡΪ%.3f\r\n", rxdata_union.AHRS_DATA.yaw);
		 printf("ȡٶȼֵx=%.3fy=%.3fz=%.3f\r\n", rxdata_union.AHRS_DATA.imu[0],rxdata_union.AHRS_DATA.imu[1],rxdata_union.AHRS_DATA.imu[2]);
		 printf("ȡֵx=%.3fy=%.3fz=%.3f\r\n\r\n\r\n", rxdata_union.AHRS_DATA.imu[3],rxdata_union.AHRS_DATA.imu[4],rxdata_union.AHRS_DATA.imu[5]);
	  
	  }	  
      HAL_Delay(100);//ʱ100ms
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_LSI|RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.LSIState = RCC_LSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 4;
  RCC_OscInitStruct.PLL.PLLN = 168;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_5) != HAL_OK)
  {
    Error_Handler();
  }
}

/* ڻص */
void HAL_UART_RxCpltCallback(UART_HandleTypeDef *UartHandle)
{


  if(UartHandle==&huart2) //жǷΪ2
  {

      imu_rx(RxBuffer);//յ2ݽн
	  while(HAL_UART_Receive_IT(&huart2, &RxBuffer, 1) != HAL_OK);//һж

	}
	
}
/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

